Fix rtd merge job to handle new tag uploaded
[releng/global-jjb.git] / shell / tox-run.sh
index ef2481d..8be8459 100644 (file)
@@ -1,4 +1,4 @@
-#!/bin/bash
+#!/bin/bash -l
 # SPDX-License-Identifier: EPL-1.0
 ##############################################################################
 # Copyright (c) 2017 The Linux Foundation and others.
 ##############################################################################
 echo "---> tox-run.sh"
 
-# Ensure we fail the job if any steps fail.
-# DO NOT set -u as virtualenv's activate script has unbound variables
-set -e -o pipefail
+ARCHIVE_TOX_DIR="$WORKSPACE/archives/tox"
+mkdir -p "$ARCHIVE_TOX_DIR"
+cd "$WORKSPACE/$TOX_DIR" || exit 1
 
-cd "$WORKSPACE/$TOX_DIR"
+if [ -d "/opt/pyenv" ]; then
+    echo "---> Setting up pyenv"
+    export PYENV_ROOT="/opt/pyenv"
+    export PATH="$PYENV_ROOT/bin:$PATH"
+    PYTHONPATH="$(pwd)"
+    export PYTHONPATH
+    export TOX_TESTENV_PASSENV=PYTHONPATH
+fi
 
-if [ -n "$TOX_ENVS" ];
-then
-    tox -e "$TOX_ENVS"
+PARALLEL="${PARALLEL:-true}"
+if [ "${PARALLEL}" = true ]; then
+    if [ -n "$TOX_ENVS" ]; then
+        tox -e "$TOX_ENVS" --parallel auto --parallel-live | tee -a "$ARCHIVE_TOX_DIR/tox.log"
+        tox_status="${PIPESTATUS[0]}"
+    else
+        tox --parallel auto --parallel-live | tee -a "$ARCHIVE_TOX_DIR/tox.log"
+        tox_status="${PIPESTATUS[0]}"
+    fi
 else
-    tox
+    if [ -n "$TOX_ENVS" ]; then
+        tox -e "$TOX_ENVS" | tee -a "$ARCHIVE_TOX_DIR/tox.log"
+        tox_status="${PIPESTATUS[0]}"
+    else
+        tox | tee -a "$ARCHIVE_TOX_DIR/tox.log"
+        tox_status="${PIPESTATUS[0]}"
+    fi
 fi
+
+# Disable SC2116 as we want to echo a space separated list of TOX_ENVS
+# shellcheck disable=SC2116
+for i in .tox/*/log; do
+    tox_env=$(echo "$i" | awk -F'/' '{print $2}')
+    cp -r "$i" "$ARCHIVE_TOX_DIR/$tox_env"
+done
+
+echo "Completed tox runs."
+
+test "$tox_status" -eq 0 || exit "$tox_status"